/*
   These routines may be adapted for any purpose when
   used with the MPC Code Development system.  No
   warranty is implied or given as to their usability
   for any purpose.

        (c) Copyright 1995

        Byte Craft Limited
        Waterloo, Ontario
        Canada N2J 4E4
        (519) 888-6911

        Sherif Abdel-Kader
*/

// Example on using macros.
//

#include <16c57.h>

// ALL NUMBERS ASSUME A CLOCK SPEED OF 20MHZ
// i.e. THE INSTRUCTION CLOCK IS 5MHZ.
//
// This macro causes a delay of multiples of 1us
// for example, when called as DELAY 100 it
// has a total delay of 100us or 0.1ms
//
// Note the use of LABEL to pass parameters to
// the macro. Also the backslash in front of
// labels local to the macro. Variable declarations
// can be made using RMB and RMW.
// The run time of the first two instructions in
// the macro can be considered negligible compared
// to the time of the loop inside the macro.

#asm
     MACRO DELAY LABEL

COUNT RMB 1
                       // Cycle count
       MOVLW  LABEL    //      1
       MOVWF  COUNT    //      1
\L1
       NOP             //      1
       NOP                     1
       DECFSZ COUNT    //      1
       GOTO   \L1      //      2

     ENDM
#endasm


void main() {
   unsigned int i;

     __TRIS(0xFF,PORTB);  // PORTB as input
     __TRIS(0x00,PORTC);  // PORTC as output

     // Read PORTB, wait 0.1ms then write to PORTC
     for (i=0 ; i<10 ; i++) { // Do it 100 times
            FSR = PORTB;
       #asm ( RADIX DEC);
       #asm ( DELAY 100); // Delay 0.1ms
            PORTC = FSR;
     }
}
