/*
   These routines may be adapted for any purpose when
   used with the MPC Code Development system.  No
   warranty is implied or given as to their usability
   for any purpose.

        (c) Copyright 1995

        Byte Craft Limited
        Waterloo, Ontario
        Canada N2J 4E4
        (519) 888-6911

        Sherif Abdel-Kader

*/

/*
  This example shows parameter passing to functions
  by value as well as by reference. Passing by
  reference is accomplished by passing the address
  of the variable to the function. Function add1()
  returns 8 whereas add2() returns 9. The x = x+1
  statement in add1 only affects the parameter
  'x' but not the original variable 'a'.
  In add2() 'a' is incremented.
*/

#include <16C71.h>

int add1(int x, int y);
int add2(int near *x, int y);

void main()
{
  int a, b, c, d;

  a = 5;
  b = 3;
  c = add1(a,b);     // 'a' is passed by value
  d = add2(&a,b);    // 'a' is passed by reference
}

int add1(int x, int y)
{
 x = x+1;
 return(x+y);
}

int add2(int near *x, int y)
{
 *x = *x + 1;
 return(*x+y);
}



