/*
   These routines may be adapted for any purpose when
   used with the MPC Code Development system.  No
   warranty is implied or given as to their usability
   for any purpose.

        (c) Copyright 1995

        Byte Craft Limited
        Waterloo, Ontario
        Canada N2J 4E4
        (519) 888-6911

        Sherif Abdel-Kader
*/

// This is an example on parameter passing to functions
// through the W and FSR (index) registers. W and FSR
// are accessed here through the #pragma directives
// regix and regw. Check out the other example PASSWFSR.C
//
// Notes:
//
// 1. Before calling the function, make sure you
//    assign FSR first and then W in order not to
//    destroy the contents of W.
// 2. Inside the function, read W first, then FSR.
//
// 3. The W register is already defined as WREG.
//    The #pragma method described here is consistant
//    with other Byte Craft compilers.

#include <16C84.h>
#pragma regix __IX;
#pragma regw __WREG;

int f1();

void main() {
int a;
 __IX = 0x05;
 __WREG = 0x03;
a = f1();
}

f1() {
  int x,y,z;
  x = __WREG;
  y = __IX;
  z = x + y;
  return(z);
}

